`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:32:02 05/26/2016 
// Design Name: 
// Module Name:    binary_counter 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////


// 6144 MHz version
/*
module binary_counter_original(
    input clk,
	 input aresetn,
    input pps,
    output [9:0] val
    );

reg [9:0] usec = 10'd0;
reg [12:0] int_cnt_reg = 13'd0;
reg reset_done = 1'b0;

always @(negedge clk, negedge aresetn)
begin
	if(aresetn == 1'b0)
		begin
			reset_done <= 1'b0;
			int_cnt_reg <= 13'd0;
			usec <= 10'd0;
		end
	else if(pps  == 1'b1 & reset_done == 1'b0)
		begin
			int_cnt_reg <= 13'd0;
			usec <= 10'd0;
			reset_done <= 1'b1;
		end

	else
		begin
			// check if we have pps pulse in proper place ( in the middle of 10uS pulse that has been captured at initial stage)
			if(pps == 1'b0)
				reset_done <= 1'b0;

			//one cycle used for actual nulling this reg
			if(int_cnt_reg < 13'd6399) begin
				int_cnt_reg <= int_cnt_reg+1;
			end else begin
				int_cnt_reg <= 13'd0;
				//if(usec < 10'd999) begin
					usec <= usec+1;
				//end else begin
				//	usec <= 10'd0;
				//end
			end
		end

end




assign val = usec;

endmodule
*/




module binary_counter(
    input clk,
	 input aresetn,
    input pps,
    input set_time,
    input  [31:0] time_in,
    output [43:0] val_time,
	 input [12:0] delay_pulses
    );

reg [9:0] msec = 10'd0;
reg [13:0] int_cnt_reg = 14'd0;
reg reset_done = 1'b0;
reg [31:0] time_val;
reg [1:0] time_is_setted = 2'd0;
reg time_is_setted2;
//reg [2:0] delayed_state = 3'b000; //128

//wire pps_local;
reg pps_local;
always @(posedge clk)
begin
	pps_local <= pps;
end

always @(posedge clk, negedge aresetn)
begin
	if(aresetn == 1'b0)
		begin
			reset_done <= 1'b0;
			int_cnt_reg <= 13'd0;
			msec <= 10'd0;
			time_is_setted <= 2'd0;
			time_val <= 32'hFFFFF000; // 1 hour for backup

		end
	else if(pps_local  == 1'b1 & reset_done == 1'b0)
		begin
			int_cnt_reg <= 13'd0;
			msec <= 10'd0;
			reset_done <= 1'b1;
			if (set_time == 1'b1 && time_is_setted < 2'd2) begin
				if(time_is_setted == 2'd1 && time_val != time_in)
					time_is_setted <= 2'd2;
				else
					time_is_setted <= 2'd1;
				time_val <= time_in;
			end

			if (time_is_setted == 2'd2)
//			if (time_is_setted == 1'b1)
			begin
				time_val<=time_val+1;
			end
		end
	else
		begin
			// check if we have pps pulse in proper place (
			// in the middle of 10uS pulse that has been captured at initial stage)
			// we also lost 1 clock pulse here...
			if(pps_local == 1'b0)
				reset_done <= 1'b0;

			//one cycle used for actual nulling this reg
			//if(int_cnt_reg < 14'd12288) begin
			if(int_cnt_reg < 14'd12287) begin
				int_cnt_reg <= int_cnt_reg+1;
			end else begin
				int_cnt_reg <= 14'd0;
				//if(msec < 10'd999) begin
				msec <= msec+1;
				//end else begin
				//	msec <= 10'd0;
				//end
			end
			
		end
end

/*
reg pps_local_reg;
reg [13:0] pulses_cnt_reg;
reg reset2_done;

always @(posedge clk, negedge aresetn)
begin
	if(aresetn == 1'b0)
		begin
			reset2_done <= 1'b0;
			pulses_cnt_reg <= 14'd0;
			pps_local_reg <= 1'b0;
		end
	else if(pps == 1'b1 & reset2_done == 1'b0)
		begin
			pulses_cnt_reg <= 14'd0;
			reset2_done <= 1'b1;
			pps_local_reg <= 1'b0;
		end
	else
		begin
			// check if we have pps pulse in proper place (
			// in the middle of 10uS pulse that has been captured at initial stage)
			// we also lost 1 clock pulse here...
			if(pps == 1'b0)
				reset2_done <= 1'b0;
				
			//one cycle used for actual nulling this reg
			if(pulses_cnt_reg < 14'd16383) begin
				pulses_cnt_reg <= pulses_cnt_reg+1;
				if (pulses_cnt_reg == {delay_pulses, 1'b0}) begin
					pps_local_reg <= 1'b1;
				end
			end else begin
				pps_local_reg <= 1'b0;
			end
		end
end


assign pps_local = pps_local_reg;
*/
//assign pps_local = pps;

/*
//for clock
reg [9:0] usec; //1024
reg [5:0] sec;  //64
reg [5:0] min;  //64
reg [4:0] hour; //32
//for calendar
reg [4:0] day;  //32
reg [3:0] month;//16
reg [6:0] year; //128
*/
wire ns_higher;
wire ns_equal;
//assign ns_higher = 1'b0;
//assign ns_equal = 1'b1;
//IS OK!!!
assign ns_higher = (int_cnt_reg[13:2] > delay_pulses[12:1]);
assign ns_equal = (int_cnt_reg[13:2] == delay_pulses[12:1]);
//assign ns_higher = (int_cnt_reg[13:0] > {delay_pulses[12:0], 1'b0} );
//assign ns_equal = (int_cnt_reg[13:0] == {delay_pulses[12:0], 1'b0} );

//assign val_time = { 32'd0, msec };
assign val_time = { time_val, msec, ns_higher, ns_equal };

endmodule
