`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    17:20:19 05/11/2016 
// Design Name: 
// Module Name:    gpsdo_pulses_cnt 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module gpsdo_pulses_cnt(
    input clk,
    input aresetn,
    input clk_tocount,
    input pps,
	 input gpsdo_en,
	 input [15:0] pps_init,
    output pwm_out,
    output reg pulses_valid
    );

wire pps_pedge;
wire pps_trig;
wire pps_nedge;
//wire clk_pedge;
reg [25:0] pulses_cnt;
reg pps_prev = 1'b0;
//reg clk_prev;
reg [1:0] pps_cnt = 2'b00;

reg [15:0] pulses_out;

wire [10:0] pulses_step;
wire is_higher;
reg pps_sync;

always @(posedge clk_tocount)
begin
	pps_sync <= pps & gpsdo_en;
end


/****************************************************
 * clock pulses counter (1PPS synced)
 ****************************************************/
always @(posedge clk_tocount or negedge aresetn)
begin
	if (!aresetn) begin
		pulses_out <= 16'd32767;
		pulses_cnt <= 26'd0;
		pulses_valid <= 1'b0;
	end
	else
	begin
		if(pps_pedge) begin
			if(pps_trig) begin
				if(is_higher)
					pulses_out <= pulses_out - pulses_step;
				else
					pulses_out <= pulses_out + pulses_step;
				pulses_valid <= (pulses_step <= 11'd4);
				pulses_cnt <= 26'd0;
			end
			pps_cnt <= pps_cnt + 1;
		end else
			pulses_cnt <= pulses_cnt + 1;
		pps_prev <= pps_sync;
	end
end



assign pps_pedge = (pps_sync & !pps_prev);
assign pps_trig = (pps_cnt == 2'b11);

wire [25:0] pulses_diff;

assign is_higher = (pulses_cnt > 26'd49152000);
assign pulses_diff = is_higher ? (pulses_cnt - 26'd49152000) : (26'd49152000 - pulses_cnt);  // comparator
assign pulses_step =  (pulses_diff > 26'd1023) ? (11'd2047) : (
							 (pulses_diff > 26'd8) ? (pulses_diff << 1) : pulses_diff);




/****************************************************
 * PWM generator
 ****************************************************/

reg [15:0] pwm_cnt;
always @(posedge clk or negedge aresetn)
 //always @(negedge aclk or negedge aresetn_in)
begin
	if (!aresetn) begin
		pwm_cnt <= 16'd0;//is reset
	end else begin
		pwm_cnt <= pwm_cnt+1;//not reset
	end
end

wire [15:0] pulses_compare;
assign pulses_compare = (gpsdo_en) ? pulses_out : pps_init;

assign pwm_out = (pulses_compare > pwm_cnt);

endmodule
